unit InsertOptions;

// *****************************************************************************
// * Copyright 2003 mxbee                                                      *
// *****************************************************************************
// * This program is free software; you can redistribute it and/or modify      *
// * it under the terms of the GNU General Public License as published by      *
// * the Free Software Foundation; either version 2 of the License, or         *
// * (at your option) any later version.                                       *
// *                                                                           *
// * This program is distributed in the hope that it will be useful,           *
// * but WITHOUT ANY WARRANTY; without even the implied warranty of            *
// * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
// * GNU General Public License for more details.                              *
// *                                                                           *
// * You should have received a copy of the GNU General Public License         *
// * along with this program; if not, write to the Free Software               *
// * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
// *****************************************************************************

{$INCLUDE CompilerOpts.pas}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, FreenetUtils;

type
  TFrmInsertOptions = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    RbFuqid: TRadioButton;
    RbFIW: TRadioButton;
    RbFProxy: TRadioButton;
    LbMimeType: TLabel;
    EdMimeType: TEdit;
    BtOk: TButton;
    BtCancel: TButton;
    RbFrost: TRadioButton;
    procedure RbClick(Sender: TObject);
    procedure BtOkClick(Sender: TObject);
  private
    FStyle: TInsertStyle;
  public
  end;

function  AskInsertOptions(var Style: TInsertStyle): Boolean;

implementation

{$R *.dfm}

function  AskInsertOptions(var Style: TInsertStyle): Boolean;
var frm: TFrmInsertOptions;
begin
  frm := TFrmInsertOptions.Create(Application);
  try
    frm.FStyle := Style;
    Result := (frm.ShowModal = mrOk);
    if Result then Style := frm.FStyle;
  finally
    frm.Free;
  end;
end;

procedure TFrmInsertOptions.RbClick(Sender: TObject);
begin
  LbMimeType.Enabled := RbFProxy.Checked;
  EdMimeType.Enabled := LbMimeType.Enabled;
end;

procedure TFrmInsertOptions.BtOkClick(Sender: TObject);
begin
  if RbFuqid.Checked then
    FStyle := InsertStyle_Fuqid
  else if RbFIW.Checked then
    FStyle := InsertStyle_FIW
  else if RbFProxy.Checked then begin
    FStyle := InsertStyle_FProxy;
    FStyle.FixedMimeType := EdMimeType.Text;
    if FStyle.FixedMimeType = '' then begin
      MessageDlg('You must specify the mime type for FProxy-style inserts, since FProxy depends on the webbrowser to get it.', mtError, [mbOk], 0);
      exit;
    end;
    if Pos('/',FStyle.FixedMimeType) = 0 then begin
      MessageDlg('Invalid mime type: ' + FStyle.FixedMimeType, mtError, [mbOk], 0);
      exit;
    end;
  end else if RbFrost.Checked then
    FStyle := InsertStyle_Frost
  else
    raise Exception.Create('No insert style selected');
  ModalResult := mrOk;
end;

end.
